> For the complete documentation index, see [llms.txt](https://docs.eximee.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.eximee.com/documentation/documentation-en/budowanie-aplikacji/logika-biznesowa/scriptcode/skrypty-scriptservice/api-skryptow/operacje-matematyczne-w-scriptcode.md).

# Mathematical operations in ScriptCode

## Mathematical operations in ScriptCode

It is recommended that **all mathematical operations** in `scriptCode` be performed through the object `BigDecimal`.

***

### API Interface

#### `big-decimal.interface.ts`

**BigDecimal**

```typescript
interface BigDecimal {
  valueOf(value: string | number | BigDecimal): BigDecimal
  add(augend: string | number | BigDecimal): BigDecimal
  subtract(subtrahend: string | number | BigDecimal): BigDecimal
  multiply(multiplicand: string | number | BigDecimal): BigDecimal
  divide(divisor: string | number | BigDecimal): BigDecimal
  divide(divisor: string | number | BigDecimal, roundingMode: string): BigDecimal
  divide(divisor: string | number | BigDecimal, scale: number): BigDecimal
  divide(divisor: string | number | BigDecimal, scale: number, roundingMode: string): BigDecimal
  setScale(newScale: number): BigDecimal
  setScale(newScale: number, roudingMode: string): BigDecimal
  equals(equated: string | number | BigDecimal): boolean
  compareTo(compared: string | number | BigDecimal): int 
}
```

#### `decimal-format.interface.ts`

```typescript
interface DecimalFormat {
  of(pattern: string): DecimalFormat
  of(pattern: string, symbols: DecimalFormatSymbols): DecimalFormat
  format(value: BigDecimal): string
  parse(value: string): BigDecimal
}
```

#### `rounding-mode.interface.ts`

```typescript
enum RoundingMode {
  UP,
  DOWN,
  CEILING,
  FLOOR,
  HALF_UP,
  HALF_DOWN,
  HALF_EVEN
}
```

#### `decimal-format-symbols.interface.ts`

```typescript
enum DecimalFormatSymbols {
  PL,
  EN,
  ES,
  SK,
  CZ
}
```

#### `random.interface.ts`

```typescript
interface Random {
  uuid(): string
}
```

### BigDecimal

#### Object creation

```typescript
var value = BigDecimal.valueOf("10.1000"); // Recommended
```

{% hint style="warning" %}
Object `BigDecimal` is **immutable**.\
Operations such as `add()` do not change the value; they require assigning the result to a variable.
{% endhint %}

***

#### Mathematical operations

**Addition**

```typescript
let value = BigDecimal.valueOf("1");
value = value.add("5"); // 1 + 5 = 6
```

**Subtraction**

```typescript
let value = BigDecimal.valueOf("100");
value = value.subtract("5"); // 100 - 5 = 95
```

**Division**

```typescript
let value = BigDecimal.valueOf("100");
value = value.divide("10"); // 100 / 10 = 10
value = value.divide("3", 5, RoundingMode.UP); // 10 / 3 = 3.33334
```

**Multiplication**

```typescript
let value = BigDecimal.valueOf("1");
value = value.multiply("20"); // 1 * 20 = 20
```

**Setting the scale**

```typescript
value = BigDecimal.valueOf("10.1000");
value = value.setScale(2); // = 10.10
value = value.setScale(1, RoundingMode.HALF_UP); // = 10.1
```

**Comparison and equality**

```typescript
value.equals("10"); // false
value.compareTo("5"); // 1
```

***

### DecimalFormat

A class for formatting decimal numbers in different languages.\
Documentation: [DecimalFormat (Java)](https://docs.oracle.com/javase/8/docs/api/java/text/DecimalFormat.html)

#### Example

```typescript
let decimalFormatPL = DecimalFormat.of("#.#", DecimalFormatSymbols.PL);
decimalFormatPL.format(BigDecimal.valueOf("34.567")); // 34,6
```

#### Patterns

| Symbol | Meaning                                        |
| ------ | ---------------------------------------------- |
| `0`    | Digit placeholder                              |
| `#`    | Digit placeholder (0 omitted)                  |
| `,`    | Decimal separator                              |
| `%`    | Multiplies by 100 and displays as a percentage |
| `E`    | Scientific notation                            |

***

### Rounding numbers (`RoundingMode`)

| Mode        | Description                                    |
| ----------- | ---------------------------------------------- |
| `HALF_UP`   | Rounds up if the decimal part is ≥ 0.5         |
| `CEILING`   | Always rounds up to the nearest integer        |
| `DOWN`      | Always down                                    |
| `FLOOR`     | Down to the nearest integer                    |
| `HALF_DOWN` | Rounds down if < 0.5                           |
| `HALF_EVEN` | Banker's rounding (to the nearest even number) |

***

### Preferred result scales

<https://docs.oracle.com/en/java/javase/17/docs/api/java.base/java/math/BigDecimal.html>

| Operation   | Result scale                                |
| ----------- | ------------------------------------------- |
| Add         | `max(addend.scale(), augend.scale())`       |
| Subtract    | `max(minuend.scale(), subtrahend.scale())`  |
| Multiply    | `multiplier.scale() + multiplicand.scale()` |
| Divide      | `dividend.scale() - divisor.scale()`        |
| Square root | `radicand.scale()/2`                        |

***

### Random

Generating UUID identifiers (version 4):

```typescript
function callService(context) {
  return [{ 'output': Random.uuid() }];
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.eximee.com/documentation/documentation-en/budowanie-aplikacji/logika-biznesowa/scriptcode/skrypty-scriptservice/api-skryptow/operacje-matematyczne-w-scriptcode.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
